-- Chatroll
-- Arxae -- Silvermoon EU
--------------------------------
-- YOU CAN CHANGE VALUES HERE ----------------------------------------------------
Colors = {																		--
	w 		= { r = 255,	g = 128, 	b = 255 },		-- normal whispers		--
	bn 		= { r = 0,		g = 255, 	b = 255 },		-- battlenet whispers	--
	chan	= { r = 255, 	g = 192, 	b = 192 },		-- channels				--
	p 		= { r = 170, 	g = 170, 	b = 255 },		-- party				--
	ra 		= { r = 255, 	g = 127, 	b = 0 },		-- raid					--
	rl		= { r = 255, 	g = 72, 	b = 9 },		-- raid leader			--
	g 		= { r = 64, 	g = 255, 	b = 64 },		-- guild chat			--
	o 		= { r = 64, 	g = 192, 	b = 64 },		-- officer chat			--
}																				--
-- Don't edit below here ---------------------------------------------------------
---------------------------

CROptions = {
	channels = {
		whispers 		=	true,
		bnetwhispers	=	true,
		chgeneral		=	false,	-- Not yet implemented :3
		chtrade			=	false,	-- Not yet implemented :3
		chlfg			=	false,	-- Not yet implemented :3
		party			=	true,
		raid			=	false,
		raidleader		=	true,
		guild			=	true,
		officer			=	true
	},
	options = {
		crIsEnabled		=	true,
		sticky			=	true,
		scrollarea		=	"notification"
	}
}

version = "0.9.0a"
_DEBUG = false

function chatroll_OnLoad(self)
	self:RegisterEvent("CHAT_MSG_WHISPER")
	self:RegisterEvent("CHAT_MSG_BN_WHISPER")
	self:RegisterEvent("CHAT_MSG_PARTY")
	self:RegisterEvent("CHAT_MSG_RAID")
	self:RegisterEvent("CHAT_MSG_RAID_LEADER")
	self:RegisterEvent("CHAT_MSG_GUILD")
	self:RegisterEvent("CHAT_MSG_OFFICER")
	print("Chatroll v" .. version)
end

SLASH_CHATROLL1, SLASH_CHATROLL2 = '/chatroll', '/cr'
function SlashCmdList.CHATROLL(msg, editbox)
	local slash, arg1, arg2 = strsplit(" ", editbox:GetText())	-- split the text at the spaces, slash var is /cr itself
	
	if(arg1 == "w" or arg1 == "whispers") then
		if(arg2 == "on") then
			CROptions.channels.whispers = true; print("Whispers will be displayed")
		elseif(arg2 == "off") then
			CROptions.channels.whispers = false; print("Whispers will not be displayed")
		end
	elseif(arg1 == "bn" or arg1 == "bnet") then
		if(arg2 == "on") then
			CROptions.channels.bnetwhispers = true; print("BNetWhispers will be displayed")
		elseif(arg2 == "off") then
			CROptions.channels.bnetwhispers = false; print("BNetWhispers will not be displayed")
		end
	elseif(arg1 == "p" or arg1 == "party") then
		if(arg2 == "off") then
			CROptions.channels.party = true; print("Party chat will be displayed")
		elseif(arg2 == "off") then
			CROptions.channels.party = false; print("Party chat will not be displayed")
		end
	elseif(arg1 == "ra" or arg1 == "raid") then
		if(arg2 == "on") then
			CROptions.channels.raid = true; print("Raid chat will be displayed")
		elseif(arg2 == "off") then 
			CROptions.channels.raid = false; print("Raid chat will not be displayed")
		end
	elseif(arg1 == "rl" or arg1 == "raidleader") then
		if(arg2 == "on") then
			CROptions.channels.raidleader = true; print("Raidleader chat will be displayed")
		elseif(arg2 == "off") then
			CROptions.channels.raidleader = false; print("Raidleader chat will not be displayed")
		end
	elseif(arg1 == "g" or arg1 == "guild") then
		if(arg2 == "on") then
			CROptions.channels.guild = true; print("Guildchat will be displayed")
		elseif(arg2 == "off") then
			CROptions.channels.guild = false; print("Guildchat will not be displayed")
		end
	elseif(arg1 == "o" or arg1 == "officer") then
		if(arg2 == "on") then
			CROptions.channels.officer = true; print("Officer chat will be displayed")
		elseif(arg2 == "off") then
			CROptions.channels.officer = false; print("Officer chat will not be displayed")
		end
	elseif(arg1 == "on") then CROptions.options.crIsEnabled = true; print("Chatroll is now on")
	elseif(arg1 == "off") then CROptions.options.crIsEnabled = false; print("Chatroll is now off")
	elseif(arg1 == "area") then
		if(arg2 == nil) then
			print("Please enter the name of the scrollarea (Case sensitive). If the area cannot be found then the notification area will be used")
			print("Current area is: " .. CROptions.options.scrollarea)
		else
			CROptions.options.scrollarea = arg2
			print("Scrollarea set to: " .. arg2)
		end
	elseif(arg1 == "sticky") then
		if(arg2 == "on") then
			CROptions.options.sticky = true; print("Sticky style will be used")
		elseif(arg2 == "off") then
			CROptions.options.sticky = false; print("Sticky style will not be used")
		end
	elseif(arg1 == "debug") then
		if(_DEBUG == false) 
			then _DEBUG = true; print("debug on")
			else _DEBUG = false; print("debug off")
		end
	elseif(arg1 == "test") then
		CRDisplay("Testmessage", "me", CROptions.options.scrollarea, Colors.w.r, Colors.w.g, Colors.w.b)
	else
		print("Chatroll v" .. version .. " - by Arxae (Silvermoon EU)")
		print("use /cr or /chatroll with one of the following arguments")
		print("Third argument is on/off (eg: /cr w on turns whisper display on")
		print("w/whisper | bn/bnet | p/part | ra/raid | rl/raidleader | g/guild | o/officer")
		print("use on or off to turn hide the display (eg: /cr on)")
		print("scrollarea <name> to configure in what area it should display")
		print("sticky <on|off>: use stick msbt style to display")
	end
end

function chatroll_OnEvent(self, event, ...)
	local msg, sender, language, cstring, target, flags, null, cnum, cname = ...
	
	if(CROptions.options.crIsEnabled == true) then -- cr is on :D
		if(event == "CHAT_MSG_WHISPER") then 
			if(CROptions.channels.whisper == true) then
				CRDisplay(msg, sender, CROptions.options.scrollarea, Colors.w.r, Colors.w.g, Colors.w.b)
			end		
		elseif(event == "CHAT_MSG_BN_WHISPER") then 
			if(CROptions.channels.bnetwhispers == true) then
				CRDisplay(msg, sender, CROptions.options.scrollarea, Colors.bn.r, Colors.bn.g, Colors.bn.b)
			end
		elseif(event == "CHAT_MSG_PARTY") then 
			if(CROptions.channels.party == true) then
				CRDisplay(msg, sender, CROptions.options.scrollarea, Colors.p.r, Colors.p.g, Colors.p.b)
			end
		elseif(event == "CHAT_MSG_RAID") then 
			if(CROptions.channels.raid == true) then
				CRDisplay(msg, sender, CROptions.options.scrollarea, Colors.ra.r, Colors.ra.g, Colors.ra.b)
			end
		elseif(event == "CHAT_MSG_RAID_LEADER") then 
			if(CROptions.channels.raidleader == true) then
				CRDisplay(msg, sender, CROptions.options.scrollarea, Colors.rl.r, Colors.rl.g, Colors.rl.b)
			end
		elseif(event == "CHAT_MSG_GUILD") then 
			if(CROptions.channels.guild == true) then
				CRDisplay(msg, sender, CROptions.options.scrollarea, Colors.g.r, Colors.g.g, Colors.g.b)
			end
		elseif(event == "CHAT_MSG_OFFICER") then
			if(CROptions.channels.officer == true) then
				CRDisplay(msg,sender, CROptions.options.scrollarea, Colors.o.r, Colors.o.g, Colors.o.b)
			end
		end
	end
end

-- MSBT Wrapper function
function CRDisplay(msg, sender, scrollarea, cr, cg, cb)
	if(_DEBUG == false) then
		if(sender == (UnitName("player"))) then
			return
		end
	end
	
	local message = sender .. ": " .. msg
	
	MikSBT.DisplayMessage(message, CROptions.options.scrollarea, CROptions.options.sticky, cr, cg, cb)
end